java.rmi.server

## Class UnicastRemoteObject

- java.lang.Object
- - java.rmi.server.RemoteObject
  - - java.rmi.server.RemoteServer
    - - java.rmi.server.UnicastRemoteObject

All Implemented Interfaces:
  Serializable, Remote

Direct Known Subclasses:
  ActivationGroup

    public class UnicastRemoteObject
    extends RemoteServer

Used for exporting a remote object with JRMP and obtaining a stub that communicates to the remote object.

For the constructors and static `exportObject` methods below, the stub for a remote object being exported is obtained as follows:

- If the remote object is exported using the `UnicastRemoteObject.exportObject(Remote)` method, a stub class (typically pregenerated from the remote object's class using the `rmic` tool) is loaded and an instance of that stub class is constructed as follows.
  - A "root class" is determined as follows: if the remote object's class directly implements an interface that extends `Remote`, then the remote object's class is the root class; otherwise, the root class is the most derived superclass of the remote object's class that directly implements an interface that extends `Remote`.
  - The name of the stub class to load is determined by concatenating the binary name of the root class with the suffix `"_Stub"`.
  - The stub class is loaded by name using the class loader of the root class. The stub class must extend `RemoteStub` and must have a public constructor that has one parameter, of type `RemoteRef`.
  - Finally, an instance of the stub class is constructed with a `RemoteRef`.
- If the appropriate stub class could not be found, or the stub class could not be loaded, or a problem occurs creating the stub instance, a `StubNotFoundException` is thrown.

- For all other means of exporting:

  - If the remote object's stub class (as defined above) could not be loaded or the system property `java.rmi.server.ignoreStubClasses` is set to `"true"` (case insensitive), a `Proxy` instance is constructed with the following properties:
    - The proxy's class is defined by the class loader of the remote object's class.
    - The proxy implements all the remote interfaces implemented by the remote object's class.
    - The proxy's invocation handler is a `RemoteObjectInvocationHandler` instance constructed with a `RemoteRef`.
    - If the proxy could not be created, a `StubNotFoundException` will be thrown.

  - Otherwise, an instance of the remote object's stub class (as described above) is used as the stub.

Since:
  JDK1.1
See Also:
  Serialized Form

### Field Summary

### Fields inherited from class java.rmi.server.RemoteObject

`ref`

### Constructor Summary

Constructors
`protected` `UnicastRemoteObject()` Creates and exports a new UnicastRemoteObject object using an anonymous port.
`protected` `UnicastRemoteObject(int port)` Creates and exports a new UnicastRemoteObject object using the particular supplied port.
`protected` `UnicastRemoteObject(int port, RMIClientSocketFactory csf, RMIServerSocketFactory ssf)` Creates and exports a new UnicastRemoteObject object using the particular supplied port and socket factories.

### Method Summary

Methods
`Object` `clone()` Returns a clone of the remote object that is distinct from the original.
`static RemoteStub` `exportObject(Remote obj)` Exports the remote object to make it available to receive incoming calls using an anonymous port.
`static Remote` `exportObject(Remote obj, int port)` Exports the remote object to make it available to receive incoming calls, using the particular supplied port.
`static Remote` `exportObject(Remote obj, int port, RMIClientSocketFactory csf, RMIServerSocketFactory ssf)` Exports the remote object to make it available to receive incoming calls, using a transport specified by the given socket factory.
`static boolean` `unexportObject(Remote obj, boolean force)` Removes the remote object, obj, from the RMI runtime.

### Methods inherited from class java.rmi.server.RemoteServer

`getClientHost, getLog, setLog`

### Methods inherited from class java.rmi.server.RemoteObject

`equals, getRef, hashCode, toString, toStub`

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### UnicastRemoteObject

    protected UnicastRemoteObject()
                           throws RemoteException

Creates and exports a new UnicastRemoteObject object using an anonymous port.

Throws:
  `RemoteException` - if failed to export object
Since:
  JDK1.1

#### UnicastRemoteObject

    protected UnicastRemoteObject(int port)
                           throws RemoteException

Creates and exports a new UnicastRemoteObject object using the particular supplied port.

Parameters:
  `port` - the port number on which the remote object receives calls (if `port` is zero, an anonymous port is chosen)
Throws:
  `RemoteException` - if failed to export object
Since:
  1.2

#### UnicastRemoteObject

    protected UnicastRemoteObject(int port,
                       RMIClientSocketFactory csf,
                       RMIServerSocketFactory ssf)
                           throws RemoteException

Creates and exports a new UnicastRemoteObject object using the particular supplied port and socket factories.

Parameters:
  `port` - the port number on which the remote object receives calls (if `port` is zero, an anonymous port is chosen)
  `csf` - the client-side socket factory for making calls to the remote object
  `ssf` - the server-side socket factory for receiving remote calls
Throws:
  `RemoteException` - if failed to export object
Since:
  1.2

### Method Detail

#### clone

    public Object clone()
                 throws CloneNotSupportedException

Returns a clone of the remote object that is distinct from the original.

Overrides:
  `clone` in class `Object`
Returns:
  the new remote object
Throws:
  `CloneNotSupportedException` - if clone failed due to a RemoteException.
Since:
  JDK1.1
See Also:
  `Cloneable`

#### exportObject

    public static RemoteStub exportObject(Remote obj)
                                   throws RemoteException

Exports the remote object to make it available to receive incoming calls using an anonymous port.

Parameters:
  `obj` - the remote object to be exported
Returns:
  remote object stub
Throws:
  `RemoteException` - if export fails
Since:
  JDK1.1

#### exportObject

    public static Remote exportObject(Remote obj,
                      int port)
                               throws RemoteException

Exports the remote object to make it available to receive incoming calls, using the particular supplied port.

Parameters:
  `obj` - the remote object to be exported
  `port` - the port to export the object on
Returns:
  remote object stub
Throws:
  `RemoteException` - if export fails
Since:
  1.2

#### exportObject

    public static Remote exportObject(Remote obj,
                      int port,
                      RMIClientSocketFactory csf,
                      RMIServerSocketFactory ssf)
                               throws RemoteException

Exports the remote object to make it available to receive incoming calls, using a transport specified by the given socket factory.

Parameters:
  `obj` - the remote object to be exported
  `port` - the port to export the object on
  `csf` - the client-side socket factory for making calls to the remote object
  `ssf` - the server-side socket factory for receiving remote calls
Returns:
  remote object stub
Throws:
  `RemoteException` - if export fails
Since:
  1.2

#### unexportObject

    public static boolean unexportObject(Remote obj,
                         boolean force)
                                  throws NoSuchObjectException

Removes the remote object, obj, from the RMI runtime. If successful, the object can no longer accept incoming RMI calls. If the force parameter is true, the object is forcibly unexported even if there are pending calls to the remote object or the remote object still has calls in progress. If the force parameter is false, the object is only unexported if there are no pending or in progress calls to the object.

Parameters:
  `obj` - the remote object to be unexported
  `force` - if true, unexports the object even if there are pending or in-progress calls; if false, only unexports the object if there are no pending or in-progress calls
Returns:
  true if operation is successful, false otherwise
Throws:
  `NoSuchObjectException` - if the remote object is not currently exported
Since:
  1.2

Copyright © 1993, 2017, Oracle and/or its affiliates. All rights reserved.